/* Virginia Tech Cognitive Radio Open Source Systems
 * Virginia Tech, 2009
 *
 * LICENSE INFORMATION GOES HERE
 */

/* TODO description of this file
 */

#ifndef CBR_H
#define CBR_H


#include "sqlite3.h"


/* TODO
 */
#define DATABASENAME "cactus_cbr"

/* TODO What exactly are these?? They don't appear to ever be used in the actual
 * code?
 */
#define EQ 0    // equals
#define NE 1    // not equals
#define GT 2    // greater than
#define GE 3    // greater than or equal to
#define LT 4    // less than
#define LE 5    // less than or equal to



/* TODO  Please explain me.
 */
struct cbr_s {
    char filename[64];
    char tablename[64];
    char command[2048];
    sqlite3 *db; 
    unsigned int num_columns;
};

typedef cbr_s * cbr;

/* TODO I don't think these functions do what you want them to do.  The
 * cbr_create is returning an object by value, which means the object that is
 * being malloc'd in the cbr_create function is effectively a memory leak, since
 * you lose the reference to that memory, and instead return a copy of the data
 * in that memory space. */
cbr cbr_create(char * _filename, char * _tablename, char * _cols[], \
        unsigned int _len);
void cbr_free(cbr _cbr);

void cbr_print(cbr _cbr);

int cbr_search(cbr _cbr, char *_names[], int * _ops, float *_vals, \
        unsigned int _n, float *_retvals);

int cbr_add_row(cbr _cbr, char *_cols[], float *_vals, unsigned int _len);


// open a database or create a database if it does not exist
int OpenDatabase(cbr _cbr);


// simple callback function, display result
int callback(void *notUsed, int argc, char **argv, char **azColName);


// execute command
int ExecuteCommand(cbr _cbr);


// execute search command
int ExecuteSearchCommand(cbr _cbr, float *_retvals);


// print 
void cbr_print(cbr _cbr);


// cbr search
int cbr_search(cbr _cbr, char *_names[], int * _ops, float *_vals, \
        unsigned int _n, float *_retvals);

// update a row 
int cbr_update(cbr _cbr, char *_where[], char*_set[], float *_wherevals, \
        float *_setvals, unsigned int _wherelen, unsigned int _setlen);

// cbr add a row
int cbr_add_row(cbr _cbr, char *_cols[], float *_vals, unsigned int _len);

#endif
